---
title: 'Logical properties for margins, borders and padding'
slug: Web/CSS/CSS_Logical_Properties/Margins_borders_padding
tags:
  - CSS
  - CSS Logical Properties
  - Guide
  - concepts
  - writing modes
---
<p>{{CSSRef}}</p>

<p class="summary">The <a href="https://drafts.csswg.org/css-logical/">Logical Properties and Values specification</a> defines flow-relative mappings for the various margin, border, and padding properties and their shorthands. In this guide we take a look at these.</p>

<p>If you have looked at the main page for <a href="/en-US/docs/Web/CSS/CSS_Logical_Properties">CSS Logical Properties and Values</a> you will see there are a huge number of properties listed. This is mostly due to the fact that there are four longhand values each for margin, border, and padding side, plus all the shorthand values.</p>

<h2 id="Mappings_for_margins_borders_and_padding">Mappings for margins, borders, and padding</h2>

<p>The specification details mappings for each logical value to a physical counterpart. In the table below I have given these mapped values assuming that the {{cssxref("writing-mode")}} in use is <code>horizontal-tb</code> — with a left to right direction. The inline direction therefore runs horizontally — left to right — and {{cssxref("margin-inline-start")}} would be equivalent to {{cssxref("margin-left")}}.</p>

<p>If you were using a <code>horizontal-tb</code> writing mode with a right-to-left text direction then {{cssxref("margin-inline-start")}} would be the same as {{cssxref("margin-right")}}, and in a vertical writing mode it would be the same as using {{cssxref("margin-top")}}.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Logical property</th>
   <th scope="col">Physical Property</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{cssxref("border-block-end")}}</td>
   <td>{{cssxref("border-bottom")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-end-color")}}</td>
   <td>{{cssxref("border-bottom-color")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-end-style")}}</td>
   <td>{{cssxref("border-bottom-style")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-end-width")}}</td>
   <td>{{cssxref("border-bottom-width")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-start")}}</td>
   <td>{{cssxref("border-top")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-start-color")}}</td>
   <td>{{cssxref("border-top-color")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-start-style")}}</td>
   <td>{{cssxref("border-top-style")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-start-width")}}</td>
   <td>{{cssxref("border-top-width")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-end")}}</td>
   <td>{{cssxref("border-right")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-end-color")}}</td>
   <td>{{cssxref("border-right-color")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-end-style")}}</td>
   <td>{{cssxref("border-right-style")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-end-width")}}</td>
   <td>{{cssxref("border-right-width")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-start")}}</td>
   <td>{{cssxref("border-left")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-start-color")}}</td>
   <td>{{cssxref("border-left-color")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-start-style")}}</td>
   <td>{{cssxref("border-left-style")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-start-width")}}</td>
   <td>{{cssxref("border-left-width")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-start-start-radius")}}</td>
   <td>{{cssxref("border-top-left-radius")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-start-end-radius")}}</td>
   <td>{{cssxref("border-bottom-left-radius")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-end-start-radius")}}</td>
   <td>{{cssxref("border-top-right-radius")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("border-end-end-radius")}}</td>
   <td>{{cssxref("border-bottom-right-radius")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-block-end")}}</td>
   <td>{{cssxref("margin-bottom")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-block-start")}}</td>
   <td>{{cssxref("margin-top")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-inline-end")}}</td>
   <td>{{cssxref("margin-right")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-inline-start")}}</td>
   <td>{{cssxref("margin-left")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-block-end")}}</td>
   <td>{{cssxref("padding-bottom")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-block-start")}}</td>
   <td>{{cssxref("padding-top")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-inline-end")}}</td>
   <td>{{cssxref("padding-right")}}</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-inline-start")}}</td>
   <td>{{cssxref("padding-left")}}</td>
  </tr>
 </tbody>
</table>

<p>There are also some additional shorthands, made possible because we have the ability to target both block or both inline edges of the box simultaneously. These shorthands have no physical equivalent.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Property</th>
   <th scope="col">Purpose</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{cssxref("border-block")}}</td>
   <td>Sets {{cssxref("border-color")}}, {{cssxref("border-style")}}, and {{cssxref("border-width")}} for both block borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-color")}}</td>
   <td>Sets <code>border-color</code> for both block borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-style")}}</td>
   <td>Sets <code>border-style</code> for both block borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-block-width")}}</td>
   <td>Sets <code>border-width</code> for both block borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline")}}</td>
   <td>Sets <code>border-color</code>, <code>-style</code>, and <code>-width</code> for both inline borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-color")}}</td>
   <td>Sets <code>border-color</code> for both inline borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-style")}}</td>
   <td>Sets <code>border-style</code> for both inline borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("border-inline-width")}}</td>
   <td>Sets <code>border-width</code> for both inline borders.</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-block")}}</td>
   <td>Sets all the block {{cssxref("margin")}}s.</td>
  </tr>
  <tr>
   <td>{{cssxref("margin-inline")}}</td>
   <td>Sets all the inline <code>margin</code>s.</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-block")}}</td>
   <td>Sets the block {{cssxref("padding")}}.</td>
  </tr>
  <tr>
   <td>{{cssxref("padding-inline")}}</td>
   <td>Sets the inline <code>padding</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Margin_examples">Margin examples</h2>

<p>The mapped margin properties of {{cssxref("margin-inline-start")}}, {{cssxref("margin-inline-end")}}, {{cssxref("margin-block-start")}}, and {{cssxref("margin-inline-end")}} can be used instead of their physical counterparts.</p>

<p>In the example below I have created two boxes and added different sized margins to each edge. I have added an extra container with a border in order to make the margin more obvious to see.</p>

<p>One box uses physical properties and the other logical properties. Try changing the {{cssxref("direction")}} property to <code>rtl</code> to cause the boxes to display in a right-to-left direction, the margins on the first box will stay in the same place, while the margins on the inline dimension of the second box will switch.</p>

<p>You can also try changing the <code>writing-mode</code> from <code>horizontal-tb</code> to <code>vertical-rl</code>. Again, notice how the margins stay in the same place for the first box, but switch around to follow the text direction in the second.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/margin-longhands.html", '100%', 700)}}</p>

<h3 id="Margin_shorthands">Margin shorthands</h3>

<p>As we can now target both sides of a box — either both inline sides or both block sides — there are new shorthands available, {{cssxref("margin-inline")}} and {{cssxref("margin-block")}}, which accept two values. The first value will apply to the start of that dimension, the second to the end. If you only use one value it is applied to both.</p>

<p>In a horizontal writing mode this CSS would apply a 5px margin to the top of the box and a 10px margin to the bottom.</p>

<pre class="brush: css">.box {
  margin-block: 5px 10px;
}</pre>

<div class="notecard note">
<p><strong>Note</strong>: The shorthand properties <code>margin-inline</code> and <code>margin-block</code> shipped in Firefox 66. As these are new properties check browser support before using.</p>
</div>

<h2 id="Padding_examples">Padding examples</h2>

<p>The mapped padding properties of {{cssxref("padding-inline-start")}}, {{cssxref("padding-inline-end")}}, {{cssxref("padding-block-start")}}, and {{cssxref("padding-inline-end")}} can be used instead of their physical counterparts.</p>

<p>In the example below I have two boxes, one of which is using physical padding properties and the other logical padding properties. With a <code>writing-mode</code> of <code>horizontal-tb</code>, both boxes should appear the same.</p>

<p>Try changing the <code>direction</code> property to <code>rtl</code> to cause the boxes to display in a right-to-left direction. The padding on the first box will stay in the same place, whereas the padding on the inline dimension of the second box will switch.</p>

<p>You can also try changing the <code>writing-mode</code> from <code>horizontal-tb</code> to <code>vertical-rl</code>. Again, notice how the padding stays in the same place for the first box, but switches around to follow the text direction in the second.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/padding-longhands.html", '100%', 700)}}</p>

<h3 id="Padding_shorthands">Padding shorthands</h3>

<p>As with margin, there are two-value shorthands for padding — {{cssxref("padding-inline")}} and {{cssxref("padding-block")}} — which allow you to set the padding of the two inline, and two block dimensions, respectively.</p>

<p>In a horizontal <code>writing-mode</code> this CSS would apply <code>5px</code> of padding to the top of the box and 10px of padding to the bottom:</p>

<pre class="brush: css">.box {
  padding-block: 5px 10px;
}</pre>

<div class="notecard note">
<p><strong>Note</strong>: The shorthand properties <code>padding-inline</code> and <code>padding-block</code> shipped in Firefox 66. As these are new properties check browser support before using.</p>
</div>

<h2 id="Border_examples">Border examples</h2>

<p>The border properties are the main reason that Logical Properties and Values seems to have so many properties, as we have the longhands for the color, width, and style of the border on each side of a box, along with the shorthand to set all three at once for each side. As with margin and padding we have a mapped version of each physical property.</p>

<p>The demo below uses some longhands and three shorthand values. As with the other demos try changing the <code>direction</code> property to <code>rtl</code> to cause the boxes to display in a right-to-left direction, or changing the <code>writing-mode</code> from <code>horizontal-tb</code> to <code>vertical-rl</code>.</p>

<p>{{EmbedGHLiveSample("css-examples/logical/border-longhands.html", '100%', 700)}}</p>

<h3 id="New_border_shorthands">New border shorthands</h3>

<p>There are two-value shorthands to set the width, style and, color of the block or inline dimension, and two-value shorthands to set all three values in the block or inline dimension. The below code, in a horizontal writing mode, would give you a 2px green solid border on the top and bottom of the box, and a 4px dotted purple border on the left and right.</p>

<pre class="brush: css">.box {
  border-block: 2px solid green;
  border-inline-width: 4px;
  border-inline-style: dotted;
  border-inline-color: rebeccapurple;
}</pre>

<div class="notecard note">
<p><strong>Note</strong>: these two value shorthands shipped in Firefox 66, check browser support before using as other browsers may not have implemented them yet.</p>
</div>

<h3 id="Flow_relative_border-radius_properties">Flow relative border-radius properties</h3>

<p>The specification has fairly recently added flow-relative values for the {{cssxref("border-radius")}} longhands. These have not yet been implemented by any browser. The below example, in a horizontal <code>writing-mode</code>, would set the top-right border radius to 1em, the bottom-right to 0, the bottom-left to 20px and the top-left to 40px.</p>

<pre class="brush: css">.box {
  border-end-start-radius: 1em;
  border-end-end-radius: 0;
  border-start-end-radius: 20px;
  border-start-start-radius: 40px;
}</pre>

<h2 id="Indicating_logical_values_for_the_4-value_shorthand_syntax">Indicating logical values for the 4-value shorthand syntax</h2>

<p>The specification makes a suggestion for the four-value shorthands such as the <code>margin</code> property, however the final decision on how this should be indicated is as yet unresolved, and is discussed in <a href="https://github.com/w3c/csswg-drafts/issues/1282">this issue</a>.</p>

<p>Using any four-value shorthand such as margin, padding, or border will currently use the physical versions, so if following the flow of the document is important, use the longhand properties for the time being.</p>
